> ## Documentation Index
> Fetch the complete documentation index at: https://docs.herondata.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Upsert an end user entity



## OpenAPI

````yaml https://app.herondata.io/swagger patch /api/end_user_entities/{entity_heron_id}/attributes/{attribute_heron_id}/sources/{source_heron_id}
openapi: 3.0.0
info:
  contact:
    email: support@herondata.io
    name: Support
  title: Heron Data API
  version: '2021-07-19'
servers:
  - description: Production
    url: https://app.herondata.io
security:
  - ApiKeyAuth:
      - key_XXX
externalDocs:
  description: Read Tutorial
  url: https://docs.herondata.io/
paths:
  /api/end_user_entities/{entity_heron_id}/attributes/{attribute_heron_id}/sources/{source_heron_id}:
    patch:
      tags:
        - EndUserEntity
      summary: Upsert an end user entity
      parameters:
        - in: path
          name: entity_heron_id
          required: true
          schema:
            type: string
        - in: path
          name: attribute_heron_id
          required: true
          schema:
            type: string
        - in: path
          name: source_heron_id
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdateEndUserEntityAttributeSourceSchema'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EndUserEntityAttributeSourceSchema'
          description: OK
      security:
        - ApiKeyAuth: []
components:
  schemas:
    UpdateEndUserEntityAttributeSourceSchema:
      properties:
        sort_order:
          type: integer
        source_config:
          additionalProperties: {}
          type: object
        source_type:
          enum:
            - parsed_end_user_file
            - api
            - rel_6
            - end_user_enricher
            - company_attribute
            - static_value
            - end_user_query
            - broker_submission_api
      type: object
    EndUserEntityAttributeSourceSchema:
      properties:
        heron_id:
          nullable: true
          type: string
        sort_order:
          type: integer
        source_config:
          additionalProperties: {}
          type: object
        source_type:
          enum:
            - parsed_end_user_file
            - api
            - rel_6
            - end_user_enricher
            - company_attribute
            - static_value
            - end_user_query
            - broker_submission_api
      type: object
  securitySchemes:
    ApiKeyAuth:
      in: header
      name: x-api-key
      type: apiKey

````